crm.ProjetWeb/Controllers/ReservationController.cs
using crm.Domain.Entity;
using crm.Services;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;


namespace crm.ProjetWeb.Controllers
{
    public class ReservationController : Controller
    {
     IReservationService rs = new ReservationService();
        // GET: Reservation
        //liste event: instance serv event + affichage --> view feha reserver button (create post) 
        public ActionResult IndexResEvent(string str)
        {
            IEventService evs = new EventService();
            var listEvent = evs.GetMany();
            if(str != null)
            {
                var events = new List<Event>();
                foreach (Event e in listEvent)
                {

                    if (e.Nom_Event.Contains(str) || e.Place.Contains(str) || e.type.Contains(str)) {
                        events.Add(e);
                    }
                  }
                return View(events);

                /* if(searchAction=="Name")
                  { return View(evs.Get(x => x.Nom_Event == searchAction)); }
                  */

            }
            return View(listEvent);
            
        }
        public ActionResult AjouterReservation(int id)
        { 
            EventService evs = new EventService();
            IUserService user_serv = new UserService();
            ReservationService resser = new ReservationService();


            User u = user_serv.GetById(1);
            Event ev = evs.GetById(id);
            Reservation res = new Reservation();

            ev.Nb_Place--;
            evs.Update(ev);
            evs.Commit();

   

            res.EventId = id;
            res.UserId = 1;
           // res.ResId = 1;

            //     res.ResId = resser.GetAll().Count()+10;
            // res.EventId = id;

            //int userId = int.Parse(User.Identity.GetUserId());//getconnected user
            //  int userId = User.Identity.IsAuthenticated.CompareTo(1);
            // int userId = 3;
           
            resser.Add(res);

            resser.Commit();


            

            return RedirectToAction("IndexResEvent");

        }



        public ActionResult IndexMesRes()
        {
            int userId = 1;
            ReservationService serv_res = new ReservationService();
            var lst_res_src = serv_res.GetAll();
            var liste_mes_res = new List<Reservation>();

            foreach (Reservation e in lst_res_src)
            {
                    if (e.UserId == userId)
                    {
                        liste_mes_res.Add(e);
                    }
             }
                        


            return View(liste_mes_res);
            
        }

        // GET: Reservation/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Reservation/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Reservation/Create
        [HttpPost]
        public ActionResult Create(Reservation e, HttpPostedFileBase File)
        {

            //ce if va vérifier si le modéle est valide et que le file n'est pas vide(ou null)
            if (!ModelState.IsValid || File == null || File.ContentLength == 0)
            {
                RedirectToAction("Create");

            }
            rs.Add(new Reservation
            {
                ResId =e.ResId,
                EventId = e.EventId,
                UserId = e.UserId,
            });
            rs.Commit();

            return RedirectToAction("Index");
        }

        // GET: Reservation/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Reservation/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Reservation/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }
             
        // POST: Reservation/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here
                EventService evs = new EventService();

                Reservation data = rs.GetById(id);
                Event e = evs.GetById(data.EventId);

                e.Nb_Place++;
                evs.Update(e);
                evs.Commit();



                rs.Delete(x => x.ResId == id);
                rs.Commit();



                return RedirectToAction("IndexMesRes");
            }
            catch
            {
                return View();
            }
        }
        //  public ActionResult SearchEvent(int id) { }

    }
}

crm.ProjetWeb/Views/Reservation/Create.cshtml
@model crm.Domain.Entity.Reservation

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_AdminLayout.cshtml";
}

<h2>Create</h2>


@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>ReservationModel</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.UserId, "UserId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.UserId, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.UserId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.EventId, "EventId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
              @Html.EditorFor(model => model.EventId, new { htmlAttributes = new { @class = "form-control" } })             
                
                @Html.ValidationMessageFor(model => model.EventId, "", new { @class = "text-danger" })
            </div>
        </div>

        

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

crm.ProjetWeb/Views/Reservation/Delete.cshtml
@model crm.Domain.Entity.Reservation

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_FrontLayout.cshtml";
}



<br /><br />

<h3 style="padding-left:20px;">Would you like to cancel your reservation ?</h3>
<div style="text-align:center ;">
    
  

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Confirm" class="btn btn-default" /> |
            @Html.ActionLink("Cancel", "IndexMesRes")
        </div>
    }
</div>

crm.ProjetWeb/Views/Reservation/Index.cshtml
@model IEnumerable<CrmWeb.Models.ReservationModel>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_AdminLayout.cshtml";
}

<h2>Index</h2>

<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Event.Nom_Event)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.User.Nom)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.Event.Nom_Event)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.User.Nom)
        </td>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.ResId }) |
            @Html.ActionLink("Details", "Details", new { id=item.ResId }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.ResId })
        </td>
    </tr>
}

</table>

crm.ProjetWeb/Views/Reservation/IndexMesRes.cshtml
@model IEnumerable<crm.Domain.Entity.Reservation>

@{
    ViewBag.Title = "IndexMesRes";
    Layout = "~/Views/Shared/_FrontLayout.cshtml";
}


    <h2 style="padding-left:20px;">My Reservation</h2>

<div class="col-md-12">
    <table class="table">
        <tr>
            <th>
                Event
            </th>
            <th>
                Date
            </th>
            <th></th>
        </tr>

        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Event.Nom_Event)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Event.dateDebut)
                </td>
                <td>
                    @Html.ActionLink("Annuler reservation", "Delete", new { id = item.ResId }, new { @style = "background:#d80003;padding:8px;border-radius:30px;color:#fff;" })
                </td>
            </tr>
        }

    </table>
</div> 

crm.ProjetWeb/Views/Reservation/IndexResEvent.cshtml
@model IEnumerable<crm.Domain.Entity.Event>
@{
    ViewBag.Title = "Liste des evenements";
    Layout = "~/Views/Shared/_FrontLayout.cshtml";

}

<h2 style="padding-left:20px;">Upcoming events</h2>  


 

<div class="col-md-12" style="text-align:center;">

    <div class="col-md-12 ">
        <div class="input">
            <input type="text" id="edt_search" placeholder="Search your product" style="margin:16px;border-radius:30px;border:1px solid #dcdcdc;padding:8px;text-align:center;width:80%;border-top-right-radius: 0px; border-bottom-right-radius: 0px;">
    

            <a href="#" style="border-top-right-radius: 50px; border-bottom-right-radius: 50px; background-color: #d80003; color: #fff; border: none; width: 70px; text-align: center; display: inline-block; padding: 9px; margin-left: -19px;"
                onclick="window.location.href='@Url.Action("IndexResEvent", "Reservation")' + '?str=' + $('#edt_search').val()">Search</a>
        </div>
       
    </div>

    <table class="table">
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Nom_Event)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.dateDebut)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Place)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Nb_Place)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.type)
            </th>
            <th></th>
        </tr>

        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Nom_Event)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.dateDebut)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Place)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Nb_Place)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.type)
                </td>
                <td>
                    @Html.ActionLink("Reserver", "AjouterReservation", new { id = item.EventId }, new { @style = "background:#d80003;padding:8px;border-radius:2px;color:#fff;" })<!--lina l action create t ajouti event id w user id -->
                </td>
            </tr>
        }

    </table>
</div>